unit ModGrafU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, MathEdit, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Zeichnen: TButton;
    Modul: TIntEdit;
    Label1: TLabel;
    Farbenzahl: TIntEdit;
    Label2: TLabel;
    RadioGroup1: TRadioGroup;
    procedure ZeichnenClick(Sender: TObject);
    procedure FarbenzahlExit(Sender: TObject);
    procedure ModulExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    function hochmod(a, b, m: Integer): Integer;
    function verknuepfe(x, y: Integer): Integer;
    function GetColor(x, y: Integer): TColor;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


{ Hilfsfunktion fr die Modulo-Potenzierung: }
function TForm1.hochmod(a, b, m : Integer): Integer;
  var e, i : Integer;
  begin
  e := 1;
  For i := 1 to b do
    e := (e * a) Mod m;
  Result := e;
  end;

function TForm1.Verknuepfe(x, y : Integer): Integer;
  begin
  Case RadioGroup1.ItemIndex of
    1 : Result := HochMod(x, y, Modul.Value);
    2 : Result := (x*x + y*y) Mod Modul.Value;
    3 : begin
        Result := (x + y)*(x - y + Modul.Value); { Trick! Statt x^2 - y^2 !!!}
        Result := Result Mod Modul.Value;
        end;
  else { also z.B. auch im Fall "0" : }
    Result := (x*y) Mod Modul.Value;
  end; { of case }
  end;

function TForm1.GetColor(x, y : Integer): TColor;
  var r, f : Integer;
  begin
  r  := verknuepfe(x, y);
  f  := r Div (Modul.Value Div Farbenzahl.Value);
  Case f of
    0 : Result := clWhite;
    1 : Result := clBlack;
    2 : Result := clRed;
    3 : Result := clBlue;
    4 : Result := clTeal;
    5 : Result := clYellow;
    6 : Result := clMaroon;
    7 : Result := clLime;
    8 : Result := clTeal;
    9 : Result := clAqua;
   10 : Result := clSilver;
   11 : Result := clOlive;
  else
    Result := clGreen;
  end;
  end;

procedure TForm1.ZeichnenClick(Sender: TObject);
  var i, k : Integer;
  begin
  For i := 0 to Pred(Modul.Value) do
    For k := 0 to Pred(Modul.Value) do
      Canvas.Pixels[i,k] := GetColor(i, k);
  end;

procedure TForm1.FarbenzahlExit(Sender: TObject);
  begin
  If Farbenzahl.Value > 32 then
    Farbenzahl.Value := 8;
  If Farbenzahl.Value < 2 then
    Farbenzahl.Value := 2;
  end;

procedure TForm1.ModulExit(Sender: TObject);
  begin
  If Modul.Value > ClientWidth - Panel1.Width then
    Modul.Value := ClientWidth - Panel1.Width;
  If Modul.Value > ClientHeight then
    Modul.Value := ClientHeight;
  Invalidate;   { fhrt zum Lschen des vorigen Bildes,
                  wenn der Modul gendert wurde !       }
  end;

procedure TForm1.FormCreate(Sender: TObject);
  begin
  FarbenzahlExit(Sender);
  ModulExit(Sender);
  end;

end.
